<?php

session_start();
ob_start();
$do = isset($_GET['do']) ? $_GET['do'] : "";
$ajaxDoArr = array("add2SimpleReturn");
include("initiateStaticSessionCommingWithCurl.php");
if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
    array_push($ajaxDoArr, $do);
}

if (!in_array($do, $ajaxDoArr)) {
    include("../public/impOpreation.php");
}



include_once("../public/config.php");
include("../library/newUplode/uploadfunctions.php");


require_once('../models/dao/YoutubeLinkDAO.class.php');
require_once('../models/dto/YoutubeLink.class.php');
require_once('../models/mysql/YoutubeLinkMySqlDAO.class.php');
require_once('../models/mysql/ext/YoutubeLinkMySqlExtDAO.class.php');




//get the do the action
$do = $_GET['do'];

$langs = $_SESSION['erp_lang'];
include_once("../views/languages/$langs/success.php");
include_once("../views/languages/$langs/error.php");


if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("header.html");
    }
}



$youtubeLink = new YoutubeLink();
$youtubeLinkDAO = new YoutubeLinkMySqlDAO();
$youtubeLinkEX = new YoutubeLinkMySqlExtDAO();

$today = date("Y-m-d");
//check and use the condition that suite this action
if (empty($do)) {
    //here the permission check
  
    $query = '';
    $brEXist = R::getRow('select * from acceptance limit 1');
    if(!empty($brEXist))
    $query = ' AND assay.autho_id NOT IN (SELECT acc.assyas_id FROM acceptance acc WHERE acc.isdel = 0)';
    $sql =$sql = "SELECT 
            te.name AS tender_name, 
            te.the_issuing_entity, 
            bid.id AS bid_id, 
            m.member_name, 
            tech.id AS tech_id, 
            auth.id AS auth_id, 
            assay.id AS assay_id,
            assay.autho_id
        FROM assays assay
        INNER JOIN authorizations auth ON assay.autho_id = auth.id
        INNER JOIN technicalopenion tech ON auth.request_id = tech.id
        INNER JOIN bidrequest bid ON tech.request_details = bid.id
        INNER JOIN tenderannouncement te ON bid.op_id = te.id
        INNER JOIN memberships m ON bid.member_id = m.id
        WHERE assay.isdel = 0". $query;
  $results = R::getAll($sql);
    $smarty->assign('requests', $results);
    $smarty->display("Acceptanceview/add.html");
} elseif ($do == "add") {
    try { 
    
        add();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        echo $e;
        die();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "show") {
    
 $sql = "SELECT 
                acc.id AS acc_id,
                acc.comment AS acc_comment,
                acc.status,
                te.name AS tender_name, 
                te.the_issuing_entity, 
                m.member_name, 
                tech.id AS tech_id, 
                auth.id AS auth_id, 
                assay.id AS assay_id,
                acc.sys_date,
                u.employeename
            FROM acceptance acc
            INNER JOIN assays assay ON acc.assyas_id = assay.autho_id
            INNER JOIN authorizations auth ON assay.autho_id = auth.id
            INNER JOIN technicalopenion tech ON auth.request_id = tech.id
            INNER JOIN bidrequest bid ON tech.request_details = bid.id
            INNER JOIN tenderannouncement te ON bid.op_id = te.id
            INNER JOIN memberships m ON bid.member_id = m.id
            INNER JOIN user u ON acc.userid = u.userid
            WHERE acc.isdel = 0 AND assay.isdel = 0";
    $showData =R::getAll($sql);
    $smarty->assign('showData', $showData);

    $youtubes = $youtubeLinkDAO->queryAll();
    $smarty->assign("youtubes", $youtubes);

    $smarty->display("Acceptanceview/show.html");
    $smarty->assign("customCheck", 1);
} elseif ($do == "deleteFinaly") {
    try {
        $id = (int) $_GET['id'];
        deleteFinaly($id);

        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "edit") { //edit request
    $id = $_GET['id'];
    $showData = R::load('acceptance', $id);
    
    $sql = "SELECT 
                te.name AS tender_name, 
                te.the_issuing_entity, 
                bid.session_date,
                m.member_name, 
                tech.id AS tech_id, 
                auth.id AS auth_id,
                assay.id AS assay_id,
                assay.autho_id 
            FROM assays assay
            INNER JOIN authorizations auth ON assay.autho_id = auth.id
            INNER JOIN technicalopenion tech ON auth.request_id = tech.id
            INNER JOIN bidrequest bid ON tech.request_details = bid.id
            INNER JOIN tenderannouncement te ON bid.op_id = te.id
            INNER JOIN memberships m ON bid.member_id = m.id
        
            LEFT JOIN acceptance acc ON acc.assyas_id = assay.autho_id AND acc.isdel = 0
            WHERE assay.isdel = 0 
            AND (acc.id IS NULL OR assay.autho_id = ?)";
        $relatedInfo = R::getAll($sql, [$showData->assyas_id]);
        $smarty->assign('showData', $showData);
        $smarty->assign('relatedInfo', $relatedInfo);
        $smarty->display("Acceptanceview/edit.html");

        } elseif ($do == "report") {
    
 $sql = "SELECT 
                acc.id AS acc_id,
                acc.comment AS acc_comment,
                acc.status,
                te.name AS tender_name, 
                te.the_issuing_entity, 
                m.member_name, 
                tech.id AS tech_id, 
                auth.id AS auth_id, 
                assay.id AS assay_id,
                acc.sys_date,
                u.employeename
            FROM acceptance acc
            INNER JOIN assays assay ON acc.assyas_id = assay.autho_id
            INNER JOIN authorizations auth ON assay.autho_id = auth.id
            INNER JOIN technicalopenion tech ON auth.request_id = tech.id
            INNER JOIN bidrequest bid ON tech.request_details = bid.id
            INNER JOIN tenderannouncement te ON bid.op_id = te.id
            INNER JOIN memberships m ON bid.member_id = m.id
            INNER JOIN user u ON acc.userid = u.userid
            WHERE acc.isdel = 0 AND assay.isdel = 0";
    $showData =R::getAll($sql);
    $smarty->assign('showData', $showData);

    $youtubes = $youtubeLinkDAO->queryAll();
    $smarty->assign("youtubes", $youtubes);

    $smarty->display("Acceptanceview/report.html");
    $smarty->assign("customCheck", 1);

    } elseif ($do == "view") { //edit request
    $id = $_GET['id'];
    $showData = R::load('acceptance', $id);
    
    $sql = "SELECT 
                te.name AS tender_name, 
                te.the_issuing_entity, 
                bid.session_date,
                m.member_name, 
                tech.id AS tech_id, 
                auth.id AS auth_id,
                assay.id AS assay_id,
                assay.autho_id 
            FROM assays assay
            INNER JOIN authorizations auth ON assay.autho_id = auth.id
            INNER JOIN technicalopenion tech ON auth.request_id = tech.id
            INNER JOIN bidrequest bid ON tech.request_details = bid.id
            INNER JOIN tenderannouncement te ON bid.op_id = te.id
            INNER JOIN memberships m ON bid.member_id = m.id
        
            LEFT JOIN acceptance acc ON acc.assyas_id = assay.autho_id AND acc.isdel = 0
            WHERE assay.isdel = 0 
            AND (acc.id IS NULL OR assay.autho_id = ?)";
        $relatedInfo = R::getAll($sql, [$showData->assyas_id]);
        $smarty->assign('showData', $showData);
        $smarty->assign('relatedInfo', $relatedInfo);
        $smarty->display("Acceptanceview/view.html");
} elseif ($do == "update") { //edit update
    try {
        update();
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 1, 'message' => 'تمت العمليه بنجاح', 'message_en' => 'Success');
            echo json_encode($data);
        } else {
            header("location:?do=sucess");
        }
    } catch (Exception $e) {
        if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {
            $data = array('status' => 2, 'message' => 'حدث خطأ', 'message_en' => 'Error');
            echo json_encode($data);
        } else {
            header("location:?do=error");
        }
    }
} elseif ($do == "sucess") {
    //here the smarty templates
    $smarty->display("succes.html");
} elseif ($do == "error") {
    //here the smarty templates
    $smarty->display("error.html");
}


$smarty->assign("customValidation", 1);

//here the global templates
if (!in_array($do, $ajaxDoArr)) {
    if (isset($_POST['curlpost']) && $_POST['curlpost'] == 1) {

    } else {
        $smarty->display("footer.html");
    }
}

/* ===============================
  function in this CONTROLLER
  ================================ */

// add in tenderannouncement tbl
function add() {
    $request = $_POST['request'];
    $comment = $_POST['comment']; 
     $openion = (int) $_POST['openion'];
    $target_dir = "../upload/Acceptance/";

    if (!file_exists($target_dir)) {
        mkdir($target_dir, 0777, true);
    }
    $rdispense = R::dispense('acceptance');
    $rdispense->assyas_id= $request;
    $rdispense->comment = $comment;
    $rdispense->status = $openion;
        $images = [];
    foreach ($_FILES['image']['name'] as $key => $val) {
        if ($_FILES['image']['tmp_name'][$key] != "") {
            $imgname = time() . "_" . $_FILES['image']['name'][$key];
            move_uploaded_file($_FILES['image']['tmp_name'][$key], "../upload/Acceptance/" . $imgname);
            $images[] = $imgname;
        }
    }
    $rdispense->acceptance_letter = implode(',', $images);
    $rdispense->sys_date = date("Y-m-d H:i:s");
    $rdispense->userid = $_SESSION['userid'];
    $rdispense->isdel = 0;
    $id = R::store($rdispense);
    return $id;
}

function update() {

    $id = $_POST['id'];
    $request = $_POST['request'];
    $comment = $_POST['comment']; 
    $openion = (int) $_POST['openion'];
    $rupdate = R::load('acceptance', $id);
    $rupdate->assyas_id= $request;
    $rupdate->comment = $comment;
    $rupdate->status = $openion;
    function up($input, $old) {
        if (!empty($_FILES[$input]['name'][0])) {
            $files = [];
            foreach ($_FILES[$input]['name'] as $k => $v) {
                $n = time() . "_" . rand(111, 999) . "_" . $v;
                move_uploaded_file($_FILES[$input]['tmp_name'][$k], "../upload/Acceptance/" . $n);
                $files[] = $n;
            }
            return implode(',', $files);
        }
        return $_POST[$old];
    }
    $rupdate->acceptance_letter   = up('image', 'imageurl');
    $rupdate->sys_date = date("Y-m-d H:i:s");
    $rupdate->userid = $_SESSION['userid'];
    $rupdate->isdel = 0;
    
    $id = R::store($rupdate);
}

function deleteFinaly($id) { 
    
    $rupdates = R::load('acceptance', $id);
    
    if ($rupdates->id > 0) {
        $rupdates->isdel = 1;
        R::store($rupdates);
    }
}